Index: waeup/branches/ulif-layout/src/waeup/browser/static/purple.css
===================================================================
--- waeup/branches/ulif-layout/src/waeup/browser/static/purple.css	(revision 4593)
+++ waeup/branches/ulif-layout/src/waeup/browser/static/purple.css	(revision 4593)
@@ -0,0 +1,241 @@
+/* This is the bare minimum needed to create your own theme.
+In this example, all we're doing is overriding the default
+color scheme with our own. In the real world, you'd probably
+want to do more complex operations. */
+
+#hd { background-color:#5D0265; }
+.block .hd { background-color:#5D0265; color:#fff; border-bottom:10px solid #262626; }
+.block .bd h2 { color:#5D0265; }
+.block .bd h3 { color:#5D0265; }
+.spaces .hd { background-color:transparent; }
+.spaces .hd ul li { background-color:#5D0265; }
+a { color:#5D0265; }
+.tabs .hd ul li a:hover { background-color:#8d0399; }
+
+/***** Uli Stuff *****/
+
+/* Fix logo image height: as image is taller than h1 text, header area
+   explodes otherwise */
+#logo img {
+  margin-top: -45px;
+  position: relative;
+  top: 12px;
+}
+
+.actionbar { 
+  margin-top: -18px;
+  margin-bottom: 18px;
+}
+
+/* The follwing is stolen from jquery... */
+
+/* Interaction Cues
+----------------------------------*/
+.ui-state-disabled { cursor: default !important; }
+
+
+/* Icons
+----------------------------------*/
+
+/* states and images */
+.ui-icon { display: block; 
+           text-indent: -99999px; overflow: hidden;
+           background-repeat: no-repeat; }
+
+/* states and images */
+.ui-icon { width: 16px; height: 16px; background-image: url(ui-icons_222222_256x240.png); }
+.ui-widget-content .ui-icon {background-image: url(ui-icons_222222_256x240.png); }
+.ui-widget-header .ui-icon {background-image: url(ui-icons_ffffff_256x240.png); }
+.ui-state-default .ui-icon { background-image: url(ui-icons_ef8c08_256x240.png); }
+.ui-state-hover .ui-icon, .ui-state-focus .ui-icon {background-image: url(ui-icons_ef8c08_256x240.png); }
+.ui-state-active .ui-icon {background-image: url(ui-icons_ef8c08_256x240.png); }
+.ui-state-highlight .ui-icon {background-image: url(ui-icons_228ef1_256x240.png); }
+.ui-state-error .ui-icon, .ui-state-error-text .ui-icon {background-image: url(ui-icons_e73434_256x240.png); }
+
+/* positioning */
+.ui-icon-carat-1-n { background-position: 0 0; }
+.ui-icon-carat-1-ne { background-position: -16px 0; }
+.ui-icon-carat-1-e { background-position: -32px 0; }
+.ui-icon-carat-1-se { background-position: -48px 0; }
+.ui-icon-carat-1-s { background-position: -64px 0; }
+.ui-icon-carat-1-sw { background-position: -80px 0; }
+.ui-icon-carat-1-w { background-position: -96px 0; }
+.ui-icon-carat-1-nw { background-position: -112px 0; }
+.ui-icon-carat-2-n-s { background-position: -128px 0; }
+.ui-icon-carat-2-e-w { background-position: -144px 0; }
+.ui-icon-triangle-1-n { background-position: 0 -16px; }
+.ui-icon-triangle-1-ne { background-position: -16px -16px; }
+.ui-icon-triangle-1-e { background-position: -32px -16px; }
+.ui-icon-triangle-1-se { background-position: -48px -16px; }
+.ui-icon-triangle-1-s { background-position: -64px -16px; }
+.ui-icon-triangle-1-sw { background-position: -80px -16px; }
+.ui-icon-triangle-1-w { background-position: -96px -16px; }
+.ui-icon-triangle-1-nw { background-position: -112px -16px; }
+.ui-icon-triangle-2-n-s { background-position: -128px -16px; }
+.ui-icon-triangle-2-e-w { background-position: -144px -16px; }
+.ui-icon-arrow-1-n { background-position: 0 -32px; }
+.ui-icon-arrow-1-ne { background-position: -16px -32px; }
+.ui-icon-arrow-1-e { background-position: -32px -32px; }
+.ui-icon-arrow-1-se { background-position: -48px -32px; }
+.ui-icon-arrow-1-s { background-position: -64px -32px; }
+.ui-icon-arrow-1-sw { background-position: -80px -32px; }
+.ui-icon-arrow-1-w { background-position: -96px -32px; }
+.ui-icon-arrow-1-nw { background-position: -112px -32px; }
+.ui-icon-arrow-2-n-s { background-position: -128px -32px; }
+.ui-icon-arrow-2-ne-sw { background-position: -144px -32px; }
+.ui-icon-arrow-2-e-w { background-position: -160px -32px; }
+.ui-icon-arrow-2-se-nw { background-position: -176px -32px; }
+.ui-icon-arrowstop-1-n { background-position: -192px -32px; }
+.ui-icon-arrowstop-1-e { background-position: -208px -32px; }
+.ui-icon-arrowstop-1-s { background-position: -224px -32px; }
+.ui-icon-arrowstop-1-w { background-position: -240px -32px; }
+.ui-icon-arrowthick-1-n { background-position: 0 -48px; }
+.ui-icon-arrowthick-1-ne { background-position: -16px -48px; }
+.ui-icon-arrowthick-1-e { background-position: -32px -48px; }
+.ui-icon-arrowthick-1-se { background-position: -48px -48px; }
+.ui-icon-arrowthick-1-s { background-position: -64px -48px; }
+.ui-icon-arrowthick-1-sw { background-position: -80px -48px; }
+.ui-icon-arrowthick-1-w { background-position: -96px -48px; }
+.ui-icon-arrowthick-1-nw { background-position: -112px -48px; }
+.ui-icon-arrowthick-2-n-s { background-position: -128px -48px; }
+.ui-icon-arrowthick-2-ne-sw { background-position: -144px -48px; }
+.ui-icon-arrowthick-2-e-w { background-position: -160px -48px; }
+.ui-icon-arrowthick-2-se-nw { background-position: -176px -48px; }
+.ui-icon-arrowthickstop-1-n { background-position: -192px -48px; }
+.ui-icon-arrowthickstop-1-e { background-position: -208px -48px; }
+.ui-icon-arrowthickstop-1-s { background-position: -224px -48px; }
+.ui-icon-arrowthickstop-1-w { background-position: -240px -48px; }
+.ui-icon-arrowreturnthick-1-w { background-position: 0 -64px; }
+.ui-icon-arrowreturnthick-1-n { background-position: -16px -64px; }
+.ui-icon-arrowreturnthick-1-e { background-position: -32px -64px; }
+.ui-icon-arrowreturnthick-1-s { background-position: -48px -64px; }
+.ui-icon-arrowreturn-1-w { background-position: -64px -64px; }
+.ui-icon-arrowreturn-1-n { background-position: -80px -64px; }
+.ui-icon-arrowreturn-1-e { background-position: -96px -64px; }
+.ui-icon-arrowreturn-1-s { background-position: -112px -64px; }
+.ui-icon-arrowrefresh-1-w { background-position: -128px -64px; }
+.ui-icon-arrowrefresh-1-n { background-position: -144px -64px; }
+.ui-icon-arrowrefresh-1-e { background-position: -160px -64px; }
+.ui-icon-arrowrefresh-1-s { background-position: -176px -64px; }
+.ui-icon-arrow-4 { background-position: 0 -80px; }
+.ui-icon-arrow-4-diag { background-position: -16px -80px; }
+.ui-icon-extlink { background-position: -32px -80px; }
+.ui-icon-newwin { background-position: -48px -80px; }
+.ui-icon-refresh { background-position: -64px -80px; }
+.ui-icon-shuffle { background-position: -80px -80px; }
+.ui-icon-transfer-e-w { background-position: -96px -80px; }
+.ui-icon-transferthick-e-w { background-position: -112px -80px; }
+.ui-icon-folder-collapsed { background-position: 0 -96px; }
+.ui-icon-folder-open { background-position: -16px -96px; }
+.ui-icon-document { background-position: -32px -96px; }
+.ui-icon-document-b { background-position: -48px -96px; }
+.ui-icon-note { background-position: -64px -96px; }
+.ui-icon-mail-closed { background-position: -80px -96px; }
+.ui-icon-mail-open { background-position: -96px -96px; }
+.ui-icon-suitcase { background-position: -112px -96px; }
+.ui-icon-comment { background-position: -128px -96px; }
+.ui-icon-person { background-position: -144px -96px; }
+.ui-icon-print { background-position: -160px -96px; }
+.ui-icon-trash { background-position: -176px -96px; }
+.ui-icon-locked { background-position: -192px -96px; }
+.ui-icon-unlocked { background-position: -208px -96px; }
+.ui-icon-bookmark { background-position: -224px -96px; }
+.ui-icon-tag { background-position: -240px -96px; }
+.ui-icon-home { background-position: 0 -112px; }
+.ui-icon-flag { background-position: -16px -112px; }
+.ui-icon-calendar { background-position: -32px -112px; }
+.ui-icon-cart { background-position: -48px -112px; }
+.ui-icon-pencil { background-position: -64px -112px; }
+.ui-icon-clock { background-position: -80px -112px; }
+.ui-icon-disk { background-position: -96px -112px; }
+.ui-icon-calculator { background-position: -112px -112px; }
+.ui-icon-zoomin { background-position: -128px -112px; }
+.ui-icon-zoomout { background-position: -144px -112px; }
+.ui-icon-search { background-position: -160px -112px; }
+.ui-icon-wrench { background-position: -176px -112px; }
+.ui-icon-gear { background-position: -192px -112px; }
+.ui-icon-heart { background-position: -208px -112px; }
+.ui-icon-star { background-position: -224px -112px; }
+.ui-icon-link { background-position: -240px -112px; }
+.ui-icon-cancel { background-position: 0 -128px; }
+.ui-icon-plus { background-position: -16px -128px; }
+.ui-icon-plusthick { background-position: -32px -128px; }
+.ui-icon-minus { background-position: -48px -128px; }
+.ui-icon-minusthick { background-position: -64px -128px; }
+.ui-icon-close { background-position: -80px -128px; }
+.ui-icon-closethick { background-position: -96px -128px; }
+.ui-icon-key { background-position: -112px -128px; }
+.ui-icon-lightbulb { background-position: -128px -128px; }
+.ui-icon-scissors { background-position: -144px -128px; }
+.ui-icon-clipboard { background-position: -160px -128px; }
+.ui-icon-copy { background-position: -176px -128px; }
+.ui-icon-contact { background-position: -192px -128px; }
+.ui-icon-image { background-position: -208px -128px; }
+.ui-icon-video { background-position: -224px -128px; }
+.ui-icon-script { background-position: -240px -128px; }
+.ui-icon-alert { background-position: 0 -144px; }
+.ui-icon-info { background-position: -16px -144px; }
+.ui-icon-notice { background-position: -32px -144px; }
+.ui-icon-help { background-position: -48px -144px; }
+.ui-icon-check { background-position: -64px -144px; }
+.ui-icon-bullet { background-position: -80px -144px; }
+.ui-icon-radio-off { background-position: -96px -144px; }
+.ui-icon-radio-on { background-position: -112px -144px; }
+.ui-icon-pin-w { background-position: -128px -144px; }
+.ui-icon-pin-s { background-position: -144px -144px; }
+.ui-icon-play { background-position: 0 -160px; }
+.ui-icon-pause { background-position: -16px -160px; }
+.ui-icon-seek-next { background-position: -32px -160px; }
+.ui-icon-seek-prev { background-position: -48px -160px; }
+.ui-icon-seek-end { background-position: -64px -160px; }
+.ui-icon-seek-first { background-position: -80px -160px; }
+.ui-icon-stop { background-position: -96px -160px; }
+.ui-icon-eject { background-position: -112px -160px; }
+.ui-icon-volume-off { background-position: -128px -160px; }
+.ui-icon-volume-on { background-position: -144px -160px; }
+.ui-icon-power { background-position: 0 -176px; }
+.ui-icon-signal-diag { background-position: -16px -176px; }
+.ui-icon-signal { background-position: -32px -176px; }
+.ui-icon-battery-0 { background-position: -48px -176px; }
+.ui-icon-battery-1 { background-position: -64px -176px; }
+.ui-icon-battery-2 { background-position: -80px -176px; }
+.ui-icon-battery-3 { background-position: -96px -176px; }
+.ui-icon-circle-plus { background-position: 0 -192px; }
+.ui-icon-circle-minus { background-position: -16px -192px; }
+.ui-icon-circle-close { background-position: -32px -192px; }
+.ui-icon-circle-triangle-e { background-position: -48px -192px; }
+.ui-icon-circle-triangle-s { background-position: -64px -192px; }
+.ui-icon-circle-triangle-w { background-position: -80px -192px; }
+.ui-icon-circle-triangle-n { background-position: -96px -192px; }
+.ui-icon-circle-arrow-e { background-position: -112px -192px; }
+.ui-icon-circle-arrow-s { background-position: -128px -192px; }
+.ui-icon-circle-arrow-w { background-position: -144px -192px; }
+.ui-icon-circle-arrow-n { background-position: -160px -192px; }
+.ui-icon-circle-zoomin { background-position: -176px -192px; }
+.ui-icon-circle-zoomout { background-position: -192px -192px; }
+.ui-icon-circle-check { background-position: -208px -192px; }
+.ui-icon-circlesmall-plus { background-position: 0 -208px; }
+.ui-icon-circlesmall-minus { background-position: -16px -208px; }
+.ui-icon-circlesmall-close { background-position: -32px -208px; }
+.ui-icon-squaresmall-plus { background-position: -48px -208px; }
+.ui-icon-squaresmall-minus { background-position: -64px -208px; }
+.ui-icon-squaresmall-close { background-position: -80px -208px; }
+.ui-icon-grip-dotted-vertical { background-position: 0 -224px; }
+.ui-icon-grip-dotted-horizontal { background-position: -16px -224px; }
+.ui-icon-grip-solid-vertical { background-position: -32px -224px; }
+.ui-icon-grip-solid-horizontal { background-position: -48px -224px; }
+.ui-icon-gripsmall-diagonal-se { background-position: -64px -224px; }
+.ui-icon-grip-diagonal-se { background-position: -80px -224px; }
+
+span.ui-icon {
+               position: relative;
+               float: left;
+               margin-right: 4px;
+               margin-bottom: 0pt;
+               margin-left: -0pt;
+               left: 0.2em;
+               top: 50%;
+}
+a span.ui-icon { 
+                 margin-top: 4px;
+                 }
Index: waeup/branches/ulif-layout/src/waeup/browser/static/waeuptheme.css
===================================================================
--- waeup/branches/ulif-layout/src/waeup/browser/static/waeuptheme.css	(revision 4593)
+++ waeup/branches/ulif-layout/src/waeup/browser/static/waeuptheme.css	(revision 4593)
@@ -0,0 +1,13 @@
+/* This is the bare minimum needed to create your own theme.
+In this example, all we're doing is overriding the default
+color scheme with our own. In the real world, you'd probably
+want to do more complex operations. */
+ 
+#hd { background-color:#840000; }
+.block .hd { background-color:#840000; color:#fff; border-bottom:10px solid #262626; }
+.block .bd h2 { color:#840000; }
+.block .bd h3 { color:#840000; }
+.spaces .hd { background-color:transparent; }
+.spaces .hd ul li { background-color:#840000; }
+a { color:#840000; }
+.tabs .hd ul li a:hover { background-color:#cc0000; }
Index: waeup/branches/ulif-layout/src/waeup/browser/static/yuiapp.css
===================================================================
--- waeup/branches/ulif-layout/src/waeup/browser/static/yuiapp.css	(revision 4593)
+++ waeup/branches/ulif-layout/src/waeup/browser/static/yuiapp.css	(revision 4593)
@@ -0,0 +1,126 @@
+html, body { background-color:#f0f0ee; color:#222; }
+ 
+/* Make the page full bleed */
+#doc3 { margin:0; }
+ 
+/* Header */
+#hd { padding:1.2em 1.5em 0 1.5em; background-color:#7a1818; }
+h1 { font-size:230%; color:#fff; }
+ 
+#navigation { margin-top:1.5em; background-color:#262626; height:1%; }
+#navigation li { float:left; display:inline; }
+#navigation li a { display:block; color:#fff; text-decoration:none; }
+#navigation li a:hover { text-decoration:underline; }
+ 
+#primary-navigation li a { font-size:116%; padding:0.4em 1em; }
+#primary-navigation li.active a { background-color:#f0f0ee; color:#000; }
+ 
+#user-navigation { float:right; }
+#user-navigation li a { font-size:93%; padding:0.5em 1em; }
+ 
+/* Body */
+#bd { padding:1.5em; }
+h2 { font-size:153.9%; margin-bottom:0.5em; }
+h3 { font-size:153.9%; margin-bottom:0.5em; }
+ 
+/* Basic block */
+.block { margin-bottom:1.5em; }
+.block .hd { background-color:#7a1818; padding:0.7em 1em; color:#fff; border-bottom:10px solid #262626; }
+.block .hd h2, .block .hd h3 { font-size:100%; margin-bottom:0; }
+.block .bd { padding:1em; background-color:#fff; }
+.block .bd h2 { color:#7a1818; }
+.block .bd h3 { color:#7a1818; }
+ 
+/* Extend block with tabs */
+.tabs .hd { padding:0; }
+.tabs .hd ul { height:1%; }
+.tabs .hd ul li { float:left; }
+.tabs .hd ul li a { display:block; color:#fff; text-decoration:none; padding:0.5em 1em; }
+.tabs .hd ul li a:hover { background-color:#470E0E; }
+.tabs .hd ul li.active a { background-color:#262626 !important; color:#fff; text-decoration:none; } /* important! fixes IE cascade issue */
+.tabs .hd h2, .tabs .hd h3 { position:absolute; margin-left:-5000px; } /* Hidden SEO Header if needed */
+ 
+/* Extend tab block with spaced tabs */
+.spaces .hd { background-color:transparent; }
+.spaces .hd ul li { background-color:#7a1818; margin-right:0.1em; }
+ 
+/* Extend block and header to have rounded corners */
+.rounded .hd,
+.rounded .hd ul li,
+.rounded .hd ul li a,
+.rounded #navigation,
+.rounded #navigation ul li,
+.rounded #navigation ul li a {
+    -moz-border-radius-topright:7px;
+    -moz-border-radius-topleft:7px;
+    -webkit-border-top-right-radius:7px;
+    -webkit-border-top-left-radius:7px;
+}
+ 
+/* Style the horizontal rules inside .block */
+.block hr { background-color:#f0f0ee; color:#f0f0ee; height:1px; border:0; }
+ 
+/* Tables */
+table { width:100%; margin-bottom:2em; }
+table td, table th { padding:0.5em; }
+table thead { background-color:#262626; color:#fff; font-weight:bold; }
+table thead a { text-decoration:none; color:#fff; }
+table thead a:hover { text-decoration:underline; }
+table tbody a { text-decoration:underline; }
+ 
+table.zebra tbody tr:nth-child(even) {background: #eee}
+table.zebra tbody tr:nth-child(odd) {background: #fff}
+ 
+ 
+ 
+/* Pager control*/
+ul.pager { text-align:right; }
+ul.pager li { display:inline; }
+ul.pager li a { padding:0.1em 0.3em; margin-right:0.3em; border:1px solid #000; text-decoration:none; color:#000; }
+ul.pager li.active a, ul.pager li a:hover { background-color:#000; color:#fff; }
+ 
+ 
+ 
+/* Forms */
+form label { font-weight:bold; }
+form label span { font-weight:normal; color:#f00; font-size:85%; }
+form span.info { font-style:italic; color:#aaa; font-size:85%; }
+form .text { display:block; width:99%; border:1px solid #aaa; padding:0.3em; }
+form .column { width:48%; }
+form .left { float:left; }
+form .right { float:right; }
+ 
+/* Messages */
+.alert { padding:0.5em; text-align:center; }
+.error { border:2px solid #fbb; background-color:#fdd; }
+.warning { border:2px solid #fffaaa; background-color:#ffc; }
+.notice { border:2px solid #1fdf00; background-color:#bbffb6; }
+ 
+/* Lists */
+ol.list, ul.list, dl.list { margin-left:2em; margin-bottom:1em; }
+ol.list li { list-style:decimal outside; }
+ul.list li { list-style:disc outside; }
+dl.list dd { margin-left:1em; }
+ 
+ul.biglist { margin-bottom:1em; }
+ul.biglist li { margin-top:-1px; border:1px solid #f0f0ee; border-width:1px 0 1px 0; }
+ul.biglist li a { display:block; padding:0.5em 0; text-decoration:none; color:#000; }
+ul.biglist li a:hover { text-decoration:underline; }
+ 
+/* Footer */
+#ft { text-align:center; font-size:85%; padding:0.5em 1em; color:#262626; }
+ 
+/* Generics */
+p { margin-bottom:1em; }
+a { color:#7a1818; }
+strong { font-weight:bold; }
+em { font-style:italic; }
+abbr, acronym { border-bottom:1px dotted #000; cursor:help; }
+ 
+.small { font-size:85%; }
+.gray { color:#999; }
+.highlight { background-color:#ffffcc; }
+.clear { clear:both; }
+.text-left { text-align:left; }
+.text-right { text-align:right; }
+.text-center { text-align:center; }