Index: /waeup/branches/ulif-layout/src/waeup/browser/templates/sitelayout.pt
===================================================================
--- /waeup/branches/ulif-layout/src/waeup/browser/templates/sitelayout.pt	(revision 4595)
+++ /waeup/branches/ulif-layout/src/waeup/browser/templates/sitelayout.pt	(revision 4596)
@@ -1,62 +1,106 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
-"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+	  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
-<head>
-<!-- base href="http://localhost:8080/app/@@page" / -->
+  <head>
+    <title>WAeUP - your way up</title>
+    <!-- base href="http://localhost:8080/app/@@page" / -->
     <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
     <meta name="robots" content="index, follow" />
-    <tal:head content="structure provider:head" />
+    <!-- tal:head content="structure provider:head" / -->
 
     <link rel="shortcut icon" tal:attributes="href static/favicon.ico" 
 	  type="image/x-icon" />
 
-</head>
-<body id="doc233" noclass="yui-t2" class="yui-skin-sam">
-  <div id="hd">
-    <tal:header content="structure provider:header" />
-    <div id="navbar" class="yui-navset" style="text-align:right;">
-      <ul class="yui-nav">
-	<li>
-	  <a tal:attributes="href 
-			     python:view.application_url() + '/faculties'">
-	<em>Faculties</em></a></li>
-	<li>
-	  <a tal:attributes="href
-			     python:view.application_url() + '/@@search'">
-	<em>Search</em></a></li>
-      </ul>
-    </div>
-  </div>
+    <link rel="stylesheet" type="text/css" href=""
+	  tal:attributes="href static/yuiapp.css" />
+    <link rel="stylesheet" type="text/css" href=""
+	  tal:attributes="href static/purple.css" />
+    <link rel="stylesheet" type="text/css" href=""
+	  tal:attributes="href static/waeuptheme.css" />
 
-  <div id="yui-main" class="yui-main">
+  </head>
+  <body class="rounded yui-skin-sam">
+    <div id="doc3" class="yui-t2">
+      <div id="hd" role="banner">
+	<div id="hd">
+	  <tal:header content="structure provider:header" />
+	  <div id="navigation" class="yui-navset" style="text-align:right;">
+	    <ul id="primary-navigation">
+	      <li class="active"><a href="#">Home</a></li>
+	      <li>
+		<a tal:attributes="href 
+				   python:view.application_url() + '/faculties'">
+		  Faculties</a>
+	      </li>
+	      <li>
+		<a tal:attributes="href
+				   python:view.application_url() + '/@@search'">
+		  Search</a>
+	      </li>
+	    </ul>
 
-<!--
-    <tal:breadcrumbs content="structure provider:breadcrumbs" />
--->
+	    <ul id="user-navigation">
+	      <li><a href="#">Profile</a></li>
+	      <li><a href="#">Settings</a></li>
+	      <li><a href="#">Logout</a></li>
+	    </ul>
+	    <div class="clear"></div>
+	    
+	  </div>
+	</div>
+	
+      </div>
+      <div id="bd" role="main">
+	<div id="yui-main">
+	  <div class="yui-b"><div class="yui-g">
+	      
+	      <!--
+		  <tal:breadcrumbs content="structure provider:breadcrumbs" />
+		  -->
 
-    <div tal:content="structure context/@@messages">
-      MESSAGE
-    </div>
+	      <div class="block">
+		<div class="hd">
+		  <h2 tal:content="view/title"> 
+		    THE CONTENT TITLE
+		  </h2>
+		</div>
+		<div class="bd">
+		  <div class="actionbar">
+		    <tal:actionbar content="structure provider:actionbar" />
+		  </div>
 
-    <div>
-      <tal:actionbar content="structure provider:actionbar" />
-    </div>
+		  <div class="alert warning ui-state-error"
+		       tal:define="message context/@@messages"
+		       tal:condition="python: len(message)>11">
+		    <span class="ui-icon ui-icon-alert">A</span>
+		    <span tal:content="structure message"></span>
+		  </div>
 
-    <div id="innermain">
-      <div noclass="yui-b">
-	<div tal:replace="structure view/content">
-	  THE CONTENT
+		  <div tal:replace="structure view/content">
+		    THE CONTENT
+		  </div>
+
+		</div>
+	      </div>
+
+	    </div>
+	  </div>
+	</div>
+	<div class="yui-b">
+	  <div class="block">
+	    <div class="hd">
+	      <h2 tal:content="layout/getUserTitle">Username</h2>
+	    </div>
+	    <div class="bd">
+	      <tal:left content="structure provider:left" />
+	    </div>
+	  </div>
 	</div>
       </div>
+
+      <div id="ft" role="contentinfo">
+	<tal:footer content="structure provider:footer" />
+      </div>
     </div>
-  </div>
-  <div id="left" noclass="yui-b">
-    <tal:left content="structure provider:left" />
-  </div>
-
-  <div id="ft">
-    <tal:footer content="structure provider:footer" />
-  </div>
-  
-</body>
+  </body>
 </html>
Index: /waeup/branches/ulif-layout/src/waeup/browser/templates/universitypage.pt
===================================================================
--- /waeup/branches/ulif-layout/src/waeup/browser/templates/universitypage.pt	(revision 4595)
+++ /waeup/branches/ulif-layout/src/waeup/browser/templates/universitypage.pt	(revision 4596)
@@ -1,17 +1,30 @@
-<div class="unilayout" tal:content="context/name">
-  University Name
-</div>
-<h1>
+
+<h2> 
   Welcome to the WAeUP SRP of <span tal:replace="context/name">NAME</span>
-</h1>
-<div>
+</h2>
+
+<p>
   This is the default frontpage of the Student Registration Portal
   (SRP) which is part of the West African e-University Project
   (<a href="http://www.waeup.org/">WAeUP</a>).
-</div>
+</p>
 
-<div name="tableexample" class="yui-skin-sam">
-  <div tal:replace="structure view/table/renderHTML" />
-</div>
+<p>
+  First thing to do after installation is to set a new location
+  for data files (imports/exports) in the <a
+  href="datacenter">DataCenter</a>.
+</p>
 
-  
+<p>
+  You can tweak the layout starting with the page template
+  <code>universitypage.pt</code> in
+  <code>waeup/browser/templates/</code>.
+</p>
+
+<!--
+    <div name="tableexample" class="yui-skin-sam">
+    <div tal:replace="structure view/table/renderHTML" />
+    </div>
+-->
+
+