Index: WAeUP_SRP/trunk/WAeUPTables.py
===================================================================
--- WAeUP_SRP/trunk/WAeUPTables.py	(revision 4646)
+++ WAeUP_SRP/trunk/WAeUPTables.py	(revision 4693)
@@ -1623,5 +1623,6 @@
     ###)
 
-
+    
+    # for transcript only
     def getAllCourses(self,student_id): ###(
         query = Eq('student_id',student_id)
@@ -1643,5 +1644,5 @@
                 if score and str(score).isdigit() and int(score) > 0:
                     score = int(score)
-                    grade,weight = self.getGradesFromScore(score)
+                    grade,weight = self.getGradesFromScore(score,'')
                     d['weight'] = weight
                     d['grade'] = grade
Index: WAeUP_SRP/trunk/skins/waeup_fceokene/apply_admission.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_fceokene/apply_admission.py	(revision 4646)
+++ WAeUP_SRP/trunk/skins/waeup_fceokene/apply_admission.py	(revision 4693)
@@ -40,5 +40,5 @@
 headings['prence'] = 'Apply for Pre-NCE Programme (2009/2010)! '
 headings['pce'] = 'Apply for PCE Screening Test (2009/2010)! '
-headings['cest'] = 'Apply for Part-Time Degree or Diploma Programmes (2008/2009)! '
+headings['cest'] = 'Apply for Diploma Programme (2009/2010)! '
 #headings['cest'] = 'Apply for Certificate in Early Child Health (2008/2009)! '
 headings['sandwich'] = 'Apply for Sandwich Programme (2009/2010)! '
@@ -52,5 +52,5 @@
 headings_slip['pce'] = 'PCE Screening (2009/2010) Acknowledgement Slip'
 #headings_slip['cest'] = 'Common Entrance Screening (2007/2008) Acknowledgement Slip'
-headings_slip['cest'] = 'CEST Application (2008/2009) Acknowledgement Slip'
+headings_slip['cest'] = 'Application for Diploma Programme (2009/2010) Acknowledgement Slip'
 headings_slip['sandwich'] = 'Application for Sandwich Programme (2009/2010) Acknowledgement Slip'
 #headings_slip['pt'] = 'Part Time (2007/2008) Acknowledgement Slip'
@@ -84,9 +84,9 @@
 confirm['cest'] = """I hereby acknowledge by ticking this check box that if it is discovered
 at any time, that I do not possess any of the qualifications, which I have obtained, I will be
-expelled from the University and shall not be readmitted for the same or any other programme,
+expelled from the College and shall not be readmitted for the same or any other programme,
 even if I have upgraded my previous qualification or posses additional qualifications."""
 confirm['sandwich'] = """I hereby acknowledge by ticking this check box that if it is discovered
 at any time, that I do not possess any of the qualifications, which I have obtained, I will be
-expelled from the University and shall not be readmitted for the same or any other programme,
+expelled from the College and shall not be readmitted for the same or any other programme,
 even if I have upgraded my previous qualification or posses additional qualifications."""
 configuration += ('confirm',confirm),
Index: WAeUP_SRP/trunk/skins/waeup_fceokene/config_form.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_fceokene/config_form.pt	(revision 4646)
+++ WAeUP_SRP/trunk/skins/waeup_fceokene/config_form.pt	(revision 4693)
@@ -130,4 +130,15 @@
         <th>
           <label>
+            Deadline Diploma Programme Application (CEST):
+          </label>
+        </th>
+        <td>
+          <input type="text" name="date3" id="date3" value="" size="30"
+                 tal:attributes="value pprops/date3" />
+        </td>
+      </tr>        
+      <tr>
+        <th>
+          <label>
             Deadline Sandwich Application:
           </label>
Index: WAeUP_SRP/trunk/skins/waeup_nau/mail2admin.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_nau/mail2admin.py	(revision 4646)
+++ WAeUP_SRP/trunk/skins/waeup_nau/mail2admin.py	(revision 4693)
@@ -27,5 +27,5 @@
 Bcc: waeup@saoas.org
 Reply-To: %(email)s
-Subject: Contact
+Subject: NAU Contact
 
 Fullname: %(fullname)s