Index: /waeup/branches/ulif-namespace/src/waeup/sirp/__init__.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/__init__.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/__init__.py	(revision 4796)
@@ -1,4 +1,4 @@
 import grok
-from waeup.interfaces import IWAeUPObject
+from waeup.sirp.interfaces import IWAeUPObject
 from zope.annotation.attribute import AttributeAnnotations
 from zope.annotation.interfaces import IAnnotations
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/app.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/app.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/app.py	(revision 4796)
@@ -4,8 +4,8 @@
 from zope.component import createObject
 
-from waeup.interfaces import IUniversity, ICSVDataReceivers
-from waeup.authentication import setup_authentication
-from waeup.datacenter import DataCenter
-from waeup.users import UserContainer
+from waeup.sirp.interfaces import IUniversity, ICSVDataReceivers
+from waeup.sirp.authentication import setup_authentication
+from waeup.sirp.datacenter import DataCenter
+from waeup.sirp.users import UserContainer
 
 class University(grok.Application, grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/authentication.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/authentication.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/authentication.py	(revision 4796)
@@ -10,6 +10,6 @@
 from zope.securitypolicy.interfaces import IPrincipalRoleManager
 from zope.securitypolicy.principalrole import principalRoleManager
-from waeup.interfaces import IUserAccount
-import waeup.permissions
+from waeup.sirp.interfaces import IUserAccount
+import waeup.sirp.permissions
 
 def setup_authentication(pau):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser/__init__.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser/__init__.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser/__init__.py	(revision 4796)
@@ -1,3 +1,3 @@
-from waeup.browser.layout import (WAeUPPage, WAeUPLayout, WAeUPDisplayFormPage,
-                                  WAeUPEditFormPage, WAeUPAddFormPage,
-                                  NullValidator)
+from waeup.sirp.browser.layout import (
+    WAeUPPage, WAeUPLayout, WAeUPDisplayFormPage, WAeUPEditFormPage,
+    WAeUPAddFormPage, NullValidator)
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser/breadcrumbs.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser/breadcrumbs.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser/breadcrumbs.py	(revision 4796)
@@ -6,7 +6,7 @@
 from zope.publisher.browser import TestRequest
 
-from waeup import interfaces
-from waeup.browser.interfaces import (IBreadcrumb, IBreadcrumbIgnorable,
-                                      IBreadcrumbContainer)
+from waeup.sirp import interfaces
+from waeup.sirp.browser.interfaces import (IBreadcrumb, IBreadcrumbIgnorable,
+                                           IBreadcrumbContainer)
         
 class Breadcrumb(grok.Adapter):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser/layout.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser/layout.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser/layout.py	(revision 4796)
@@ -4,5 +4,5 @@
 from hurry import yui
 from megrok.layout import Page, Layout, EditForm, DisplayForm, AddForm
-from waeup.interfaces import IWAeUPObject
+from waeup.sirp.interfaces import IWAeUPObject
 from z3c.flashmessage.interfaces import IMessageSource
 from zope.component import queryUtility, ComponentLookupError
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser/pages.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser/pages.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser/pages.py	(revision 4796)
@@ -10,15 +10,14 @@
 from hurry.query.query import Query, Text
 from hurry.workflow.interfaces import NoTransitionAvailableError
-from waeup.browser import (WAeUPPage, WAeUPEditFormPage, WAeUPAddFormPage,
-                           WAeUPDisplayFormPage, NullValidator)
-from waeup.catalog import search, search_context
-from waeup.datacenter import Import
-from waeup.interfaces import (IUniversity, IWAeUPObject, IUserContainer,
-                              IUserAccount, IFacultyContainer, IDataCenter,
-                              IFaculty, IDepartment, ICourse, ICertificate,
-                              ICertificateCourse, IWAeUPXMLImporter,
-                              IWAeUPXMLExporter)
-from waeup.widgets.interfaces import ITableProvider
-from waeup.utils.helpers import getName
+from waeup.sirp.browser import (WAeUPPage, WAeUPEditFormPage, WAeUPAddFormPage,
+                                WAeUPDisplayFormPage, NullValidator)
+from waeup.sirp.catalog import search, search_context
+from waeup.sirp.datacenter import Import
+from waeup.sirp.interfaces import (
+    IUniversity, IWAeUPObject, IUserContainer, IUserAccount,
+    IFacultyContainer, IDataCenter, IFaculty, IDepartment, ICourse,
+    ICertificate, ICertificateCourse, IWAeUPXMLImporter, IWAeUPXMLExporter)
+from waeup.sirp.widgets.interfaces import ITableProvider
+from waeup.sirp.utils.helpers import getName
 from zope import schema
 from zope.app.security.interfaces import (IAuthentication,
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/browser/viewlets.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/browser/viewlets.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/browser/viewlets.py	(revision 4796)
@@ -6,13 +6,12 @@
 from zope.component import getMultiAdapter
 from zope.location.interfaces import ISite
-from waeup.browser.pages import (UniversityPage, FacultyContainerPage,
-                                 DatacenterPage, FacultyPage, DepartmentPage,
-                                 CoursePage, CertificatePage,
-                                 CertificateCoursePage)
-from waeup.browser.interfaces import IBreadcrumbContainer
-from waeup.interfaces import (IUniversity, IWAeUPObject, IWAeUPXMLExporter,
-                              IWAeUPXMLImporter, IFacultyContainer, IFaculty,
-                              IDepartment, ICourse, ICertificate,
-                              ICertificateCourse, IDataCenter)
+from waeup.sirp.browser.pages import (
+    UniversityPage, FacultyContainerPage, DatacenterPage, FacultyPage,
+    DepartmentPage, CoursePage, CertificatePage, CertificateCoursePage)
+from waeup.sirp.browser.interfaces import IBreadcrumbContainer
+from waeup.sirp.interfaces import (
+    IUniversity, IWAeUPObject, IWAeUPXMLExporter, IWAeUPXMLImporter,
+    IFacultyContainer, IFaculty, IDepartment, ICourse, ICertificate,
+    ICertificateCourse, IDataCenter)
 
 grok.templatedir('templates')
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/catalog.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/catalog.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/catalog.py	(revision 4796)
@@ -4,7 +4,7 @@
 from hurry.query.query import Query, Text
 from hurry.query import Eq
-from waeup.app import University
-from waeup.interfaces import ICourse, ICertificateCourse
-from waeup.student.interfaces import IStudent
+from waeup.sirp.app import University
+from waeup.sirp.interfaces import ICourse, ICertificateCourse
+from waeup.sirp.student.interfaces import IStudent
 from zope.app.catalog.interfaces import ICatalog
 from zope.app.intid.interfaces import IIntIds
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/__init__.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/__init__.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/__init__.py	(revision 4796)
@@ -1,3 +1,3 @@
 # Make this a package.
-from waeup.csvfile.csvfile import getCSVFile, CSVFile
-from waeup.csvfile.util import toBool
+from waeup.sirp.csvfile.csvfile import getCSVFile, CSVFile
+from waeup.sirp.csvfile.util import toBool
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/csvfile.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/csvfile.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/csvfile.py	(revision 4796)
@@ -6,5 +6,5 @@
 import csv
 import grok
-from waeup.csvfile.interfaces import ICSVFile
+from waeup.sirp.csvfile.interfaces import ICSVFile
 
 class CSVFile(grok.Adapter):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/meta.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/meta.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/csvfile/meta.py	(revision 4796)
@@ -2,6 +2,6 @@
 """
 import martian
-import waeup.csvfile.csvfile
-from waeup.csvfile import CSVFile
+import waeup.sirp.csvfile.csvfile
+from waeup.sirp.csvfile import CSVFile
 
 # This grokker fills the registry on startup, with any class that is
@@ -10,4 +10,4 @@
     martian.component(CSVFile)
     def execute(self, klass, **kw):
-        waeup.csvfile.csvfile.csvwrappers.append(klass)
+        waeup.sirp.csvfile.csvfile.csvwrappers.append(klass)
         return True
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/datacenter.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/datacenter.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/datacenter.py	(revision 4796)
@@ -9,8 +9,8 @@
 from datetime import datetime
 from zope.component import getMultiAdapter
-from waeup.csvfile import getCSVFile
-from waeup.interfaces import (IDataCenter, IWAeUPCSVImporter,
-                              ICSVDataReceivers, IDataCenterFile)
-from waeup.utils.helpers import copyFileSystemTree
+from waeup.sirp.csvfile import getCSVFile
+from waeup.sirp.interfaces import (IDataCenter, IWAeUPCSVImporter,
+                                   ICSVDataReceivers, IDataCenterFile)
+from waeup.sirp.utils.helpers import copyFileSystemTree
 
 class DataCenter(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/hostel/hostel.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/hostel/hostel.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/hostel/hostel.py	(revision 4796)
@@ -1,4 +1,4 @@
 import grok
-from waeup.interfaces import IHostel
+from waeup.sirp.interfaces import IHostel
 
 class Hostel(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/hostel/hostelcontainer.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/hostel/hostelcontainer.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/hostel/hostelcontainer.py	(revision 4796)
@@ -2,5 +2,5 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.interfaces import IHostelContainer, IHostel
+from waeup.sirp.interfaces import IHostelContainer, IHostel
 
 class HostelContainer(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/interfaces.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/interfaces.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/interfaces.py	(revision 4796)
@@ -7,5 +7,5 @@
 from zope import schema
 from zope.schema.vocabulary import SimpleVocabulary, SimpleTerm
-from waeup.permissions import RoleSource
+from waeup.sirp.permissions import RoleSource
 
 def SimpleWAeUPVocabulary(*terms):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/student/student.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/student/student.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/student/student.py	(revision 4796)
@@ -1,5 +1,5 @@
 import grok
 from grok import index
-from waeup.student.interfaces import IStudent
+from waeup.sirp.student.interfaces import IStudent
 
 def fromCsv(a):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/student/studentcontainer.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/student/studentcontainer.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/student/studentcontainer.py	(revision 4796)
@@ -3,6 +3,6 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.interfaces import IStudentContainer
-from waeup.utils import importexport as csv
+from waeup.sirp.interfaces import IStudentContainer
+from waeup.sirp.utils import importexport as csv
 
 class StudentContainer(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/tables.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/tables.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/tables.py	(revision 4796)
@@ -2,9 +2,9 @@
 """
 import grok
-from waeup.interfaces import (IUniversity, IFacultyContainer, IFaculty,
-                              IDepartment, ICourseContainer)
-from waeup.widgets.interfaces import ITableProvider
-from waeup.widgets.table import YUITable as Table
-from waeup.widgets.table import Col
+from waeup.sirp.interfaces import (IUniversity, IFacultyContainer, IFaculty,
+                                   IDepartment, ICourseContainer)
+from waeup.sirp.widgets.interfaces import ITableProvider
+from waeup.sirp.widgets.table import YUITable as Table
+from waeup.sirp.widgets.table import Col
 from zope.security.management import checkPermission
 
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/tests/test_waeup.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/tests/test_waeup.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/tests/test_waeup.py	(revision 4796)
@@ -6,5 +6,5 @@
 import grok
 import zope.component.eventtesting
-from waeup.testing import FunctionalLayer
+from waeup.sirp.testing import FunctionalLayer
 
 def setUpZope(test):
@@ -13,4 +13,4 @@
 # Register all tests in the waeup_ng package
 test_suite = grok.testing.register_all_tests(
-    'waeup', usetup=setUpZope,
+    'waeup.sirp', usetup=setUpZope,
     layer=FunctionalLayer)
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/certificate.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/certificate.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/certificate.py	(revision 4796)
@@ -7,5 +7,5 @@
 from zope.component.interfaces import IFactory, ComponentLookupError
 from zope.interface import implementedBy
-from waeup.interfaces import ICertificate, ICertificateCourse, ICourse
+from waeup.sirp.interfaces import ICertificate, ICertificateCourse, ICourse
 
 class Certificate(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/certificatecontainer.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/certificatecontainer.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/certificatecontainer.py	(revision 4796)
@@ -2,5 +2,5 @@
 """
 import grok
-from waeup.interfaces import ICertificateContainer, ICertificate
+from waeup.sirp.interfaces import ICertificateContainer, ICertificate
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/course.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/course.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/course.py	(revision 4796)
@@ -4,5 +4,5 @@
 from zope.interface import implementedBy
 from zope.component.interfaces import IFactory
-from waeup.interfaces import ICourse
+from waeup.sirp.interfaces import ICourse
 
 class Course(grok.Model):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/coursecontainer.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/coursecontainer.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/coursecontainer.py	(revision 4796)
@@ -4,5 +4,5 @@
 from zope.interface import implementedBy
 from zope.component.interfaces import IFactory
-from waeup.interfaces import ICourseContainer, ICourse
+from waeup.sirp.interfaces import ICourseContainer, ICourse
 
 class CourseContainer(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/department.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/department.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/department.py	(revision 4796)
@@ -5,5 +5,5 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.interfaces import IDepartment
+from waeup.sirp.interfaces import IDepartment
 
 class Department(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/faculty.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/faculty.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/faculty.py	(revision 4796)
@@ -5,5 +5,5 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.interfaces import IFaculty, IDepartment
+from waeup.sirp.interfaces import IFaculty, IDepartment
 
 class Faculty(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/university/facultycontainer.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/university/facultycontainer.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/university/facultycontainer.py	(revision 4796)
@@ -2,5 +2,5 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.interfaces import IFacultyContainer, IFaculty
+from waeup.sirp.interfaces import IFacultyContainer, IFaculty
 
 class FacultyContainer(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/users.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/users.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/users.py	(revision 4796)
@@ -2,6 +2,6 @@
 """
 import grok
-from waeup.authentication import Account
-from waeup.interfaces import IUserContainer
+from waeup.sirp.authentication import Account
+from waeup.sirp.interfaces import IUserContainer
 
 class UserContainer(grok.Container):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/utils/csvimport.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/utils/csvimport.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/utils/csvimport.py	(revision 4796)
@@ -2,8 +2,8 @@
 """
 import grok
-from waeup.csvfile import CSVFile, toBool
-from waeup.csvfile.interfaces import ICSVFile
-from waeup.interfaces import IFacultyContainer, IWAeUPCSVImporter
-from waeup.utils.importexport import CSVImporter
+from waeup.sirp.csvfile import CSVFile, toBool
+from waeup.sirp.csvfile.interfaces import ICSVFile
+from waeup.sirp.interfaces import IFacultyContainer, IWAeUPCSVImporter
+from waeup.sirp.utils.importexport import CSVImporter
 from zope.app.catalog.interfaces import ICatalog
 from zope.component import createObject, getUtility
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/utils/importexport.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/utils/importexport.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/utils/importexport.py	(revision 4796)
@@ -7,7 +7,8 @@
 from xml.dom.minidom import Document, getDOMImplementation
 from zope.interface import Interface
-from waeup.csvfile.interfaces import ICSVFile
-from waeup.interfaces import (IWAeUPObject, IWAeUPExporter, IWAeUPXMLExporter,
-                              IWAeUPXMLImporter, IWAeUPCSVImporter)
+from waeup.sirp.csvfile.interfaces import ICSVFile
+from waeup.sirp.interfaces import (
+    IWAeUPObject, IWAeUPExporter, IWAeUPXMLExporter, IWAeUPXMLImporter,
+    IWAeUPCSVImporter)
 
 def readFile(f):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/widgets/table.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/widgets/table.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/widgets/table.py	(revision 4796)
@@ -4,5 +4,5 @@
 from hurry import yui
 from zope.interface import Interface
-from waeup.widgets.interfaces import ITableProvider
+from waeup.sirp.widgets.interfaces import ITableProvider
 
 def varName(string):
Index: /waeup/branches/ulif-namespace/src/waeup/sirp/workflow.py
===================================================================
--- /waeup/branches/ulif-namespace/src/waeup/sirp/workflow.py	(revision 4795)
+++ /waeup/branches/ulif-namespace/src/waeup/sirp/workflow.py	(revision 4796)
@@ -7,5 +7,5 @@
 from hurry.workflow.interfaces import IWorkflow, IWorkflowState, IWorkflowInfo
 from hurry.workflow.interfaces import IWorkflowVersions
-from waeup.interfaces import IWAeUPObject
+from waeup.sirp.interfaces import IWAeUPObject
 
 UNCHECKED = 'unchecked'