Index: WAeUP_SRP/trunk/skins/waeup_epayment/goto_interswitch_form.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_epayment/goto_interswitch_form.pt	(revision 4788)
+++ WAeUP_SRP/trunk/skins/waeup_epayment/goto_interswitch_form.pt	(revision 4799)
@@ -12,4 +12,7 @@
           <input type="hidden" tal:attributes="name python:arg[0];value python:arg[1]" />
       </span>          
+      
+      <span tal:replace = "structure info/xml_data" />       
+      
         <table>
           <tr>
@@ -30,4 +33,10 @@
             <td> Naira <span tal:content="info/amount" /></td>
           </tr>
+              
+      
+      
+      
+      
+      
       
         </table>
@@ -36,5 +45,5 @@
                class="standalone" 
                name="goto_bank" 
-               value="Proceed to Payment Gateway" 
+               value="Proceed to Interswitch Payment Gateway" 
                />
       </form>
Index: WAeUP_SRP/trunk/skins/waeup_epayment/pay_interswitch.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_epayment/pay_interswitch.py	(revision 4788)
+++ WAeUP_SRP/trunk/skins/waeup_epayment/pay_interswitch.py	(revision 4799)
@@ -1,3 +1,3 @@
-## Script (Python) "pay_online"
+##Script (Python) "pay_online"
 ##bind container=container
 ##bind context=context
@@ -48,5 +48,5 @@
 if not fee_dict or (not new and fulltime) or not (new or returning):
     return context.interswitch_form(info=info)
-info['site_id'] = '61'
+info['site_id'] = '57'
 info['currency_id'] = '566'
 if new:
@@ -55,11 +55,12 @@
     amount = info['amount'] = fee_dict['returning']
 if fulltime:
-    pay_item_id = "6100"
+    pay_item_id = "5700"
     #info['type_code'] = student_record.faculty   #type_code is redundant and will be removed soon
     info['bank'] = ''
 else:
-    pay_item_id = "6101"
+    pay_item_id = "5701"
     #info['type_code'] = student_record.course  #type_code is redundant and will be removed soon
     info['bank'] = ''
+info['surcharge'] = '0'  # Uniben doesn't show the surcharge on the slip
 info['payment_possible'] = True
 info['type_description'] = fee_dict['description']
@@ -85,8 +86,7 @@
 if True or context.portal_url().find('uniben-demo.waeup.org') >-1 or\
    context.portal_url().find('uniben.waeup.org') >-1:
+    #info['action'] = "https://webpay.interswitchng.com/test_paydirect/webpay/pay.aspx"
     info['action'] = "https://webpay.interswitchng.com/paydirect/webpay/pay.aspx"
 else:
-    #pass
-    #return None
     info['action'] = "%s/payments/%s/simulate_callback" % (student.absolute_url(),p_id)
 
@@ -110,8 +110,5 @@
 d = {}
 d.update(info)
-#from Products.zdb import set_trace;set_trace()
 payment.getContent().edit(mapping=d)
-#wftool.doActionFor(payment,'close')
-#wftool.doActionFor(student,'pay_school_fee')
 info['callback_url'] = "%s/payments/%s/interswitch_cb?echo=%s" % (student.absolute_url(),
                                                                   p_id,
@@ -132,36 +129,42 @@
     args[arg] = info[field]
 itotal = int(amount)*100
-wema_amount = 10000
-provider_amount = 35000
+fbn_amount = 10000
+bt_amount = 75000
 interswitch_amount = 15000
-#uniben_amount = itotal - wema_amount - provider_amount - interswitch_amount
-uniben_amount = itotal - interswitch_amount
+uniben_amount = itotal - fbn_amount - bt_amount - interswitch_amount
 xmldict = {}
 xmldict['detail_ref'] = args['txn_ref']
 xmldict['department'] = student_record.department
 xmldict['faculty'] = student_record.faculty
-#xmldict['wema_amt'] = "%d" % wema_amount
-#xmldict['provider_amt'] = "%d" % provider_amount
+xmldict['fbn_amt'] = "%d" % fbn_amount
+xmldict['bt_amt'] = "%d" % bt_amount
 xmldict['uniben_amt'] = "%d" % uniben_amount
-##<item_detail item_id="2" item_name="WEMA" item_amt="%(wema_amt)s" bank_id="16" acct_num="48398023902" />
-##<item_detail item_id="3" item_name="Portal Provider" item_amt="%(provider_amt)s" bank_id="47" acct_num="0980938209483" />
-xmltext = """
-<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="UNIBEN" department="%(department)s"
-faculty="%(faculty)s">
-<item_detail item_id="1" item_name="UNIBEN" item_amt="%(uniben_amt)s" bank_id="16" acct_num="384950902390" />
+#Full and Part-time students School Fees go into different Accounts 
+if student_record.mode.endswith('_ft'):
+  xmldict['uniben_acct'] = "6162030000198"
+  xmldict['bank_id'] = '8'
+else:
+    xmldict['uniben_acct'] = "6162030000277"
+    xmldict['bank_id'] = '8' 
+
+xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="UNIBEN" department="%(department)s" faculty="%(faculty)s">
+<item_detail item_id="1" item_name="UNIBEN School Fee" item_amt="%(uniben_amt)s" bank_id="%(bank_id)s" acct_num="%(uniben_acct)s" />
+<item_detail item_id="2" item_name="BT" item_amt="%(bt_amt)s" bank_id="89" acct_num="0061001000021095" />
+<item_detail item_id="3" item_name="FBN" item_amt="%(fbn_amt)s" bank_id="8" acct_num="6162030000286" />
 </item_details>
-</payment_item_detail>
-""" % xmldict
-#total = int(xmldict['uniben_amt'])+int(xmldict['wema_amt'])+int(xmldict['provider_amt'])
-total = int(xmldict['uniben_amt'])
-args['Amount'] = "%d" % (total + 15000)
+</payment_item_detail>""" % xmldict
+
+info['xml_data'] = """<input type="hidden" name="xml_data" value='%s'  />""" % xmltext
+
+args['Amount'] = "%d" % (itotal)
 args['site_name'] = "uniben.waeup.org"
 args['cust_name_desc'] = "Student Name"
 args['pay_item_id'] = pay_item_id
 args['pay_item_name'] = "UNIBEN Tuition Payments"
-args['payment_params'] = 'switch_college_split'
-#args['xml_data'] = xmltext % info
-args['xml_data'] = ''
+args['payment_params'] = 'college_split'
+#args['xml_data'] = ''
+#args['xml_data'] = xmltext   # info['xml_data']can be used instead
 info['args'] = args
+
 return context.goto_interswitch_form(info=info)