Index: waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport1page.pt
===================================================================
--- waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport1page.pt	(revision 4804)
+++ waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport1page.pt	(revision 4804)
@@ -0,0 +1,27 @@
+<h2>Manual import</h2>
+<h3>Step 1</h3>
+
+<p>
+  Please select a file for import from the list below
+</p>
+<form method="POST">
+  <table>
+    <thead>
+      <th /><th>Filename</th><th>Size</th><th>Date</th>
+    </thead>
+    <tbody>
+      <tr tal:repeat="file context/getFiles"
+	  tal:attributes="class python: repeat['file'].odd() and 'odd' or ''">
+	<td>
+	  <button type="submit" name="select"
+		  tal:attributes="value file/name"
+		  >Select</button>
+	</td>
+	<td tal:content="file/name">Filename.csv</td>
+	<td tal:content="file/size">123 Bytes</td>
+	<td tal:content="file/getDate">1.1.1970</td>
+      </tr>
+    </tbody>
+  </table>
+  <input type="submit" name="cancel" value="Cancel" />
+</form>
Index: waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport2page.pt
===================================================================
--- waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport2page.pt	(revision 4804)
+++ waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport2page.pt	(revision 4804)
@@ -0,0 +1,76 @@
+<h2>Manual import</h2>
+<h3>Step 2</h3>
+
+<form method="POST">
+  <p>
+    <b>File:</b> <span tal:content="view/filename">Filename.csv</span>
+    <input type="hidden" name="filename"
+	   tal:attributes="value view/filename" />
+  </p>
+  <p>
+    Please select an importer and an import mode from the selections below:
+  </p>
+
+  <div>
+    <table style="border: 1px solid #000;"
+	   tal:define="body view/getPreviewBody;
+		       headers view/getPreviewHeader;
+		       fieldnum python: len(headers)">
+      <thead>
+	<tr style="border: 1px solid #ccc;">
+	  <th style="border: 1px solid #888;"
+	      tal:repeat="headerfield headers"
+	      tal:content="headerfield">
+	    headerfield
+	  </th>
+	</tr>
+      </thead>
+      <tbody>
+	<tr tal:repeat="row body"
+	    tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
+	    style="border: 1px solid #000;">
+	  <td tal:repeat="value row"
+	      tal:content="value"
+	      style="border: 1px solid #000;">
+	    value
+	  </td>
+	</tr>
+      </tbody>
+    </table>
+  </div>
+
+  <div>
+    Importer:
+
+    <select name="importer">
+      <option tal:repeat="importer view/getImporters"
+	      tal:attributes="value importer/name;
+			      selected python: importer['name'] == view.importer and 'selected' or ''"
+	      tal:content="importer/title">
+	Some Importer
+      </option>
+    </select>
+
+  </div>
+
+  <p>&nbsp;</p>
+
+  <div>
+    Mode:
+
+    <input type="radio" name="mode" value="create" checked="checked"
+	   tal:attributes="checked python: view.mode == 'create' and 'checked' or ''" /> Create
+    &nbsp;&nbsp;
+    <input type="radio" name="mode" value="update"
+	   tal:attributes="checked python: view.mode == 'update' and 'checked' or ''" /> Update
+    &nbsp;&nbsp;
+    <input type="radio" name="mode" value="remove"
+	   tal:attributes="checked python: view.mode == 'remove' and 'checked' or ''" /> Remove
+
+    <p>&nbsp;</p>
+  </div>
+
+  <input type="submit" name="cancel" value="Cancel" />
+  <input type="submit" name="back1" value="Back to step 1" />
+  <input type="submit" name="proceed" value="Proceed to step 3..." />
+</form>
Index: waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport3page.pt
===================================================================
--- waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport3page.pt	(revision 4804)
+++ waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport3page.pt	(revision 4804)
@@ -0,0 +1,104 @@
+<h2>Manual import</h2>
+<h3>Step 3</h3>
+<div tal:define="warnings view/getWarnings">
+<form>
+
+  <p>
+    Eventually modify headerfields of import file below.
+  </p>
+
+  <p>
+    <b>File:</b> <span tal:content="view/filename">Filename.csv</span>
+    <input type="hidden" name="filename"
+	   tal:attributes="value view/filename" />
+  </p>
+  <p>
+    <b>Importer:</b>
+    <span tal:content="view/importer/name">Importer Name</span>
+    <input type="hidden" name="importer"
+	   tal:attributes="value view/importer/util_name" />
+  </p>
+  <p>
+    <b>Import mode: </b>
+    <span tal:content="view/mode">mode</span>
+    <input type="hidden" name="mode"
+	   tal:attributes="value view/mode" />
+  </p>
+
+  <div>
+    <div class="alert error ui-state-error"
+	 tal:condition="warnings">
+      <span class="ui-icon ui-icon-alert">A</span>
+      Current settings will give the follwing warnings, when importing:
+      <div tal:repeat="warning warnings" 
+	   tal:content="warning">
+	Warning messages
+      </div>
+    </div>
+
+    <div class="alert notice ui-state-info"
+	 tal:condition="not: warnings">
+      <span class="ui-icon ui-icon-info">A</span>
+      Header fields OK
+    </div>
+  </div>
+
+
+  <div>
+    <table style="border: 1px solid #000;"
+	   tal:define="body view/getPreviewBody;
+		       headers view/headerfields;
+		       fieldnum python: len(headers)">
+      <thead>
+	<tr style="border: 1px solid #ccc;">
+	  <th style="border: 1px solid #888;"
+	      tal:repeat="headerfield headers"
+	      tal:content="headerfield">
+	    headerfield
+	  </th>
+	</tr>
+	<tr style="border: 1px solid #ccc;">
+	  <th style="border: 1px solid #888; text-align=center;"
+	      tal:repeat="headerfield headers">
+	    <i>change to:</i>
+	  </th>
+	</tr>
+	<tr style="border: 1px solid #ccc;">
+	  <th style="border: 1px solid #888;"
+	      tal:repeat="headerfield headers">
+	    <select name="headerfield">
+	      <option tal:repeat="opt view/getPossibleHeaders"
+		      tal:attributes="value opt/value;
+				      selected python: opt['value']==headerfield and 'selected' or '';"
+		      tal:content="opt/title">
+		new_header_name
+	      </option>
+	    </select>
+	  </th>
+	</tr>
+      </thead>
+      <tbody>
+	<tr tal:repeat="row body"
+	    tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
+	    style="border: 1px solid #000;">
+	  <td tal:repeat="value row"
+	      tal:content="value"
+	      style="border: 1px solid #000;">
+	    value
+	  </td>
+	</tr>
+      </tbody>
+    </table>
+  </div>
+
+
+  <input type="submit" name="cancel" value="Cancel" />
+  <input type="reset" name="reset" value="Reset" />
+  <input type="submit" name="update" value="Set headerfields" />
+  <br />
+  <input type="submit" name="back2" value="Back to step 2" />
+  <input tal:attributes="disabled python: len(warnings) and 'disabled' or ''"
+	 type="submit" name="proceed" value="Perform import..." />
+
+</form>
+</div>
Index: waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport4page.pt
===================================================================
--- waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport4page.pt	(revision 4804)
+++ waeup/branches/ulif-importers/src/waeup/browser/templates/datacenterimport4page.pt	(revision 4804)
@@ -0,0 +1,10 @@
+<h2>Manual import</h2>
+<h3>Step 4</h3>
+<p>
+  Batch processing finished.
+</p>
+<form method="POST">
+  <input tal:condition="view/warn_num"
+	 type="submit" name="back" value="Back to step 3" />
+  <input type="submit" name="finish" value="Back to data center" />
+</form>